{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Net.THttpServer.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Net.THttpServer.RawType
import HROOT.Net.THttpServer.FFI
import HROOT.Net.THttpServer.Interface
import HROOT.Net.THttpServer.Cast
import HROOT.Net.THttpServer.RawType
import HROOT.Net.THttpServer.Cast
import HROOT.Net.THttpServer.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITHttpServer (THttpServer) where

instance () => ITNamed (THttpServer) where
        setName = xform1 c_thttpserver_setname
        setNameTitle = xform2 c_thttpserver_setnametitle
        setTitle = xform1 c_thttpserver_settitle

instance () => ITObject (THttpServer) where
        clear = xform1 c_thttpserver_clear
        draw = xform1 c_thttpserver_draw
        findObject = xform1 c_thttpserver_findobject
        getName = xform0 c_thttpserver_getname
        isA = xform0 c_thttpserver_isa
        paint = xform1 c_thttpserver_paint
        printObj = xform1 c_thttpserver_printobj
        saveAs = xform2 c_thttpserver_saveas
        write = xform3 c_thttpserver_write
        write_ = xform0 c_thttpserver_write_

instance () => IDeletable (THttpServer) where
        delete = xform0 c_thttpserver_delete

newTHttpServer :: (Castable c0 CString) => c0 -> IO THttpServer
newTHttpServer = xform0 c_thttpserver_newthttpserver

tHttpServer_SetReadOnly :: () => THttpServer -> CBool -> IO ()
tHttpServer_SetReadOnly
  = xform1 c_thttpserver_thttpserver_setreadonly
